| Nano100AN Series BSP V3.02.002 The Board Support Package for Nano100AN Series

Functions
SDCARD Library Exported Functions
NANO100 Library » SDCARD Library

## Functions
void | SD_Delay (uint32_t count)
| Delay function. More...
static uint32_t | GenerateCRC (uint32_t u32Data, uint32_t u32GenPoly, uint32_t u32Accum)
| This function is used to generate CRC value. More...
static uint32_t | SingleWrite (uint32_t u32Data)
| This function is used to send data though SPI to general clock for SDCARD operation. More...
uint32_t | MMC_Command_Exec (uint8_t nCmd, uint32_t nArg, uint8_t *pchar, uint32_t *response)
| This function is used to Send SDCARD CMD and Receive Response. More...
void | MMC_FLASH_Init (void)
| This function is used to initialize the flash card. More...
uint32_t | SDCARD_Open (void)
| This function is used to Open GPIO function and initial SDCARD. More...
void | SDCARD_Close (void)
| This function is used to close SDCARD. More...
uint32_t | SDCARD_GetCardSize (uint32_t *pu32TotSecCnt)
| This function is used to get card total sector after SDCARD is opened. More...
uint32_t | GetLogicSector (void)
| This function is used to get logic sector size. More...
void | SpiRead (uint32_t addr, uint32_t size, uint8_t *buffer)
| This function is used to Get data from SD card. More...
void | SpiWrite (uint32_t addr, uint32_t size, uint8_t *buffer)
| This function is used to store data into SD card. More...
uint32_t | SDCARD_GetVersion (void)

## Detailed Description

## Function Documentation

## ◆ GenerateCRC()

static uint32_t GenerateCRC | ( | uint32_t | u32Data,
|  | uint32_t | u32GenPoly,
|  | uint32_t | u32Accum
| ) |  |
| static

This function is used to generate CRC value.

Parameters

  [in] | u32Data | Input Data
  [in] | u32GenPoly | CRC7:0x1200, CRC16:0x1021
  [in] | u32Accum | CRC value

Returns
  CRC value

Definition at line 101 of file SDCard.c.

## ◆ GetLogicSector()

uint32_t GetLogicSector | ( | void |  | ) |

This function is used to get logic sector size.

Returns
  The Logic Sector size

Definition at line 640 of file SDCard.c.

## ◆ MMC_Command_Exec()

uint32_t MMC_Command_Exec | ( | uint8_t | nCmd,
|  | uint32_t | nArg,
|  | uint8_t * | pchar,
|  | uint32_t * | response
| ) |  |

This function is used to Send SDCARD CMD and Receive Response.

Parameters

  [in] | nCmd | Set command register
  [in] | nArg | Set command argument
  [out] | *pchar | Get register and data
  [out] | *response | Get response

Return values

  TRUE | get response
  FALSE | 1.SD Card busy, 2.Card moved, 3.Timeout

Definition at line 140 of file SDCard.c.

## ◆ MMC_FLASH_Init()

void MMC_FLASH_Init | ( | void |  | ) |

This function is used to initialize the flash card.

Returns
  none

Definition at line 447 of file SDCard.c.

## ◆ SD_Delay()

void SD_Delay | ( | uint32_t | count | ) |

Delay function.

Parameters

  [in] | count | loop count.

Returns
  none

Definition at line 74 of file SDCard.c.

## ◆ SDCARD_Close()

void SDCARD_Close | ( | void |  | ) |

This function is used to close SDCARD.

Returns
  none

Definition at line 615 of file SDCard.c.

## ◆ SDCARD_GetCardSize()

uint32_t SDCARD_GetCardSize | ( | uint32_t * | pu32TotSecCnt | ) |

This function is used to get card total sector after SDCARD is opened.

Parameters

  [out] | *pu32TotSecCnt | Get sector count

Return values

  TRUE | The size is already saved
  FALSE | The size is zero

Definition at line 626 of file SDCard.c.

## ◆ SDCARD_GetVersion()

uint32_t SDCARD_GetVersion | ( | void |  | ) |

## ◆ SDCARD_Open()

uint32_t SDCARD_Open | ( | void |  | ) |

This function is used to Open GPIO function and initial SDCARD.

Return values

  SD_FAIL | Initial SDCARD Failed
  SD_SUCCESS | Success

Definition at line 584 of file SDCard.c.

## ◆ SingleWrite()

static uint32_t SingleWrite | ( | uint32_t | u32Data | ) |
| static

This function is used to send data though SPI to general clock for SDCARD operation.

Parameters

  [in] | u32Data | Data to send

Returns
  none

Definition at line 122 of file SDCard.c.

## ◆ SpiRead()

void SpiRead | ( | uint32_t | addr,
|  | uint32_t | size,
|  | uint8_t * | buffer
| ) |  |

This function is used to Get data from SD card.

Parameters

  [in] | addr | Set start address for LBA
  [in] | size | Set data size (byte)
  [in] | buffer | Set buffer pointer

Returns
  none

Definition at line 652 of file SDCard.c.

## ◆ SpiWrite()

void SpiWrite | ( | uint32_t | addr,
|  | uint32_t | size,
|  | uint8_t * | buffer
| ) |  |

This function is used to store data into SD card.

Parameters

  [in] | addr | Set start address for LBA
  [in] | size | Set data size (byte)
  [in] | buffer | Set buffer pointer

Returns
  none

Definition at line 687 of file SDCard.c.